
/*

  $Id: transferaladin.h,v 1.2 2003/06/08 19:33:55 cramer Exp $
*/

#ifndef DT_ALADIN_H
#define DT_ALADIN_H

#define BUFSIZE (2048)
#define PROFILEBUFSIZE (1536)

/* type definitions */

typedef struct s_aladin {
  unsigned char       type;
  char               *name;
} t_aladin;

struct s_aladinsettings {
  char                model;
  char                is_air;
  char                is_nitrox;
  char                is_o2;

  /* O2 */
  char                workload;
  char                sensitivity;
  /* end O2 */

  char                beep;
  char                units;

  /* O2 */
  char                premixreset;
  /* Nitrox */
  char                po2max;

  char                reserve;
  char                brethwarning;
  unsigned int        serial;
};

struct s_aladinstatus {
  unsigned int        battery;
  unsigned char       batterystatus;
  unsigned int        totaldives;
  unsigned int        logbookoffset;
  char                numprofiles;
  unsigned int        endringbuf;
  time_t              time;
  long long           rawtime;
};


struct s_aladinlogbook {
  unsigned int        divenum;
  unsigned char       altitude;
  char                sos;
  char                workalarm;
  char                decoalarm;
  char                repeatd;
  char                acentwaring;
  char                bottomtime;
  float               maxdepth;
  char                surfaceh;
  char                surfacem;
  float               airconsumption;
  time_t              entrytime;
  float               watertemp;
};

struct s_profwarnings {
  unsigned char       transmit;
  unsigned char       work;
  unsigned char       decomissed;
  unsigned char       ascent;
  unsigned char       bottom;
  unsigned char       decostop;
};

struct s_profdeco {
  unsigned char       physeffort;
  char                skincooling;
  unsigned char       microbubble;
};

struct s_aladinprofile {
  unsigned int        divenum;
  float               ambienttemp;
  unsigned int        tissue1;
  unsigned int        tissue2;
  unsigned int        tissue3;
  unsigned int        tissue4;
  unsigned int        tissue5;
  unsigned int        tissue6;
  unsigned int        tissue7;
  unsigned int        tissue8;

  unsigned int        microbubbles;
  unsigned int        intrapulmenary;

  unsigned char       skincool;

  /* Nitrox & O2 */
  unsigned char       cnso2;
  unsigned char       nitroxmix;
  unsigned int        ppO2max;

  /* O2 only */
  unsigned char       workload;
  unsigned char       scrsens;

  float               diveprofile[700];
  struct s_profwarnings warnings[700];

  struct s_profdeco   decoinfo[230];

  /* O2 only */
  unsigned char       o2mix[230];

  int                 profilesamples;
};


void               *aladintransfer (GtkWidget * progress);
void                aladinudcfwrite (char *aladinbuf, time_t dumptime,
                                     GtkWidget * widget);

#endif
