
/*
 * 
 * $Id: callbacks.c,v 1.15 2003/08/08 22:48:23 cramer Exp $ 
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <pthread.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "include/defines.h"
#include "include/filelist.h"
#include "include/plotdive.h"
#include "include/preferences.h"
#include "include/transferaladin.h"
#include "include/printing.h"
#include "include/readudcf.h"

extern struct DiveProfile *CurrentDiveProfile;
extern struct s_preferences CurrentPreferences;

pthread_mutex_t     mymutex = PTHREAD_MUTEX_INITIALIZER;


void on_print_activate (GtkMenuItem * menuitem, gpointer user_data)
{
	GtkTreeIter         iter;
  GtkTreeModel       *model;
  int                 divenum;
  gchar              *divedate;
  gchar              *divetime;
  gchar               filename[255];

	if ((CurrentDiveProfile->filename != NULL) && (strlen(CurrentDiveProfile->filename) > 0)) {
    printUsingDiveplot(CurrentDiveProfile->filename);
	}
}


void on_preferences_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkWidget          *preferences;
  GtkWidget          *SerialPort;
  GtkWidget          *DiveNoOffset;
  GtkWidget          *TankVolume;
  char                temp[255];

  preferences = create_preferencesWindow ();
  SerialPort = lookup_widget (preferences, "SerialPort");
  DiveNoOffset = lookup_widget (preferences, "DiveNoOffset");
  TankVolume = lookup_widget (preferences, "TankVolume");

  gtk_entry_set_text (SerialPort, CurrentPreferences.aladindevice);

  sprintf (temp, "%d", CurrentPreferences.aladindiveoffset);
  gtk_entry_set_text (DiveNoOffset, temp);

  sprintf (temp, "%.2f", CurrentPreferences.tankvolume);
  gtk_entry_set_text (TankVolume, temp);

  gtk_widget_show (preferences);
}


void on_quit_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  gtk_main_quit ();
}


void on_mainWindow_destroy (GtkObject * object, gpointer user_data)
{
  gtk_main_quit ();
}


void on_printSetup_activate (GtkMenuItem * menuitem, gpointer user_data)
{

}


void on_about_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkWidget          *about;

  about = create_about ();
  gtk_widget_show (about);
}

gboolean
on_diveProfile_expose_event (GtkWidget * widget,
                             GdkEventExpose * event, gpointer user_data)
{
  GtkTreeSelection   *select;
  GtkWidget          *diveList;

  if (event->count == 0) {

    //diveList = lookup_widget (user_data, "diveList");

    //select = gtk_tree_view_get_selection (GTK_TREE_VIEW (diveList));

    //g_signal_emit_by_name(G_OBJECT(select), "changed");
    if (CurrentDiveProfile != NULL) {
      plotDive (user_data, PLOT_GRAPH);
    }
  }
  return FALSE;
}

void on_from_aladin_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  GtkWidget          *appbar;
  GtkProgress        *progress;
  pthread_t          *thread;
  int                 i = 0;

  pthread_mutex_lock (&mymutex);
  printf ("Now I shoud download something :-)\n");
  appbar = lookup_widget (menuitem, "appbar");

  gnome_appbar_set_status (appbar, "Switch your Aladin to Dive Profile 1!");
  progress = gnome_appbar_get_progress (appbar);

  pthread_create (thread, NULL, aladintransfer, (void *) progress);
  pthread_mutex_unlock (&mymutex);
  //aladintransfer(progress);
}

void on_OK_clicked (GtkButton * button, gpointer user_data)
{
  GtkWidget          *preferences;
  GtkWidget          *SerialPort;
  GtkWidget          *DiveNoOffset;
  GtkWidget          *TankVolume;
  gchar              *temp;

  preferences = lookup_widget (user_data, "preferencesWindow");
  SerialPort = lookup_widget (preferences, "SerialPort");
  DiveNoOffset = lookup_widget (preferences, "DiveNoOffset");
  TankVolume = lookup_widget (preferences, "TankVolume");

  temp = gtk_entry_get_text (SerialPort);
  sprintf (CurrentPreferences.aladindevice, "%s", temp);

  temp = gtk_entry_get_text (DiveNoOffset);
  sscanf (temp, "%d", &(CurrentPreferences.aladindiveoffset));

  temp = gtk_entry_get_text (TankVolume);
  sscanf (temp, "%f", &(CurrentPreferences.tankvolume));

  writepreferences (&CurrentPreferences);

  gtk_widget_destroy (preferences);
}


void on_Apply_clicked (GtkButton * button, gpointer user_data)
{
  GtkWidget          *preferences;
  GtkWidget          *SerialPort;
  GtkWidget          *DiveNoOffset;
  GtkWidget          *TankVolume;
  gchar              *temp;

  preferences = lookup_widget (user_data, "preferencesWindow");
  SerialPort = lookup_widget (preferences, "SerialPort");
  DiveNoOffset = lookup_widget (preferences, "DiveNoOffset");
  TankVolume = lookup_widget (preferences, "TankVolume");

  temp = gtk_entry_get_text (SerialPort);
  sprintf (CurrentPreferences.aladindevice, "%s", temp);

  temp = gtk_entry_get_text (DiveNoOffset);
  sscanf (temp, "%d", &(CurrentPreferences.aladindiveoffset));

  temp = gtk_entry_get_text (TankVolume);
  sscanf (temp, "%f", &(CurrentPreferences.tankvolume));

  writepreferences (&CurrentPreferences);
}


void on_Cancel_clicked (GtkButton * button, gpointer user_data)
{
  GtkWidget          *preferences;

  preferences = lookup_widget (user_data, "preferencesWindow");
  gtk_widget_destroy (preferences);
}

void on_preferencesWindow_destroy (GtkObject * object, gpointer user_data)
{

}

void on_refresh_filelist_activate (GtkMenuItem * menuitem, gpointer user_data)
{
  char                dirname[255];

  // Here we should reload the filelist !
  sprintf (dirname, "%s/%s", getenv ("HOME"), ALADINHOME);
  buildFileList (menuitem, dirname, 0);
}
