
/*

  $Id: preferences.c,v 1.1 2003/06/08 12:57:34 cramer Exp $
*/

#include <stdio.h>
#include <string.h>
#include "include/preferences.h"

gboolean readpreferences (struct s_preferences *config)
{
  FILE               *fd;
  char                buf[255];
  char                key[100], value[100];
  char               *sp;
  char                configfile[255];
  struct stat         cstat;

  snprintf (configfile, 255, "%s/.divetools", getenv ("HOME"));
  if (stat (configfile, &cstat) != 0) {
    snprintf (configfile, 255, "%s/divetools.conf", CFGDIR);
  }

  fd = fopen (configfile, "r");

  if (fd == NULL) {
    printf ("Config file %s/divetools.conf does not exist!\n", CFGDIR);
    return FALSE;
  }

  while (!feof (fd)) {
    buf[0] = '\0';
    fgets (buf, 255, fd);

    sp = (char *) strchr (buf, '#');
    if (sp) {
      *sp = '\0';
    }

    if (strlen (buf) > 0 && strchr (buf, '=') != NULL) {
      sscanf (buf, "%99s = %99s", key, value);

      if (strncmp ("EONDEVICE", key, 6) == 0) {
        strncpy (config->eondevice, value, S_EONDEVICE);
      }

      if (strncmp ("EONDIVEOFFSET", key, 10) == 0) {
        config->eondiveoffset = atoi (value);
      }

      if (strncmp ("ALADINDEVICE", key, 12) == 0) {
        strncpy (config->aladindevice, value, S_ALADINDEVICE);
      }

      if (strncmp ("ALADINDIVEOFFSET", key, 16) == 0) {
        config->aladindiveoffset = atoi (value);
      }

      if (strncmp ("ALADINOWNER", key, 11) == 0) {
        strncpy (config->aladinowner, value, S_ALADINOWNER);
      }

      if (strncmp ("TANKVOLUME", key, 10) == 0) {
        sscanf (value, "%f", &(config->tankvolume));
      }

      if (strncmp ("ALADINDATADIR", key, 13) == 0) {
        strncpy (config->aladindatadir, value, S_ALADINOWNER);
      }
    }

  }

  fclose (fd);
  return TRUE;
}

gboolean writepreferences (struct s_preferences * config)
{
  char                configfile[255];
  FILE               *fd;

  snprintf (configfile, 255, "%s/.divetools", getenv ("HOME"));
  fd = fopen (configfile, "w");

  if (fd) {
    fprintf (fd, "# DiveTools Config File created by galadin\n");
    fprintf (fd, "\n# Misc Settings\n");
    fprintf (fd, "TANKVOLUME = %f\n", config->tankvolume);
    fprintf (fd, "\n# Settings for the EON part of the tools\n");
    fprintf (fd, "EONDEVICE = %s\n", config->eondevice);
    fprintf (fd, "EONDIVEOFFSET = %d\n", config->eondiveoffset);
    fprintf (fd, "\n# Settings for the Aladin part of the tools\n");
    fprintf (fd, "ALADINDEVICE = %s\n", config->aladindevice);
    fprintf (fd, "ALADINDIVEOFFSET = %d\n", config->aladindiveoffset);
    fprintf (fd, "ALADINOWNER = %s\n", config->aladinowner);
    fprintf (fd, "ALADINDATADIR = %s\n", config->aladindatadir);
    fclose (fd);
    return TRUE;
  } else {
    return FALSE;
  }
}
